module Main.Types
  ( ArithOp (..),
    EqOp (..),
    OrdCmpOp (..),
    -- BinExpr (..),
    Int (..),
    Bool (..),
    Statement (..),
  )
where

import qualified Prelude as P

data ArithOp = Add | Sub | Mul | Div

data EqOp = Eq | Neq

data OrdCmpOp = GT | GTE | LT | LTE

-- newtype BinExpr op i o = BinExpr (op -> i -> i -> o)

data Int
  = Int P.Int
  | IntArith ArithOp Int Int -- (BinExpr ArithOp Int Int)

data Bool
  = Bool P.Bool
  | IntEq EqOp Int Int -- (BinExpr EqOp Int Bool)
  | IntOrdCmp OrdCmpOp Int Int -- (BinExpr OrdCmpOp Int Bool)
  | BoolEq EqOp Bool Bool -- (BinExpr EqOp Bool Bool)

data Statement
  = Print Int